%define	ver	1.14.3
%define	rel	8.72.EL

# define clime as "flimname" and the version of that clime as
# "flimver" if use clime instead of flim.
# (But clime seems to be only needed by Mule 2.3.)
%define flimname	flim
%define flimver		1.14.3

%define semiver		%{ver}
## %define wemiver	1.13.7
%define emhver		1.14.1
%define rmailmimever	1.13.0

%define apelver		10.3
%define emacsver	20.7
%define xemacsver	21.1.14-23

%define	lispdir		%{_datadir}/emacs/site-lisp
%define	pkgdir		%{_libdir}/xemacs/xemacs-packages


Name:	semi
Summary: A library which provides MIME features for Emacs 20.
Group: Applications/Editors
Version: %{ver}
Release: %{rel}
Copyright: GPL
URL:	ftp://ftp.m17n.org/pub/mule/

## Source1: ftp://ftp.m17n.org/pub/mule/flim/flim-1.14/flim-%{flimver}.tar.gz
## Source2: ftp://ftp.m17n.org/pub/mule/semi/semi-1.14-for-flim-1.14/semi-%{semiver}.tar.gz
## Source3: ftp://ftp.m17n.org/pub/mule/semi/emh-1.10/emh-%{emhver}.tar.gz
## Source4: ftp://ftp.m17n.org/pub/mule/semi/rmail-mime-1.13/rmail-mime-%{rmailmimever}.tar.gz
## Source5: ftp://ftp.jaist.ac.jp/pub/GNU/elisp/semi/wemi/wemi-%{wemiver}.tar.gz

Source1: %{flimname}-%{flimver}.tar.bz2
Source2: semi-%{semiver}.tar.bz2
Source3: emh-%{emhver}.tar.bz2
Source4: rmail-mime-%{rmailmimever}.tar.bz2

Patch0: semi-info.patch
Patch5: mime-edit.el.diff
Patch6: mime-pgp.el.diff
Patch7: semi-1.13.7-makeinfo.patch
Patch8: rmail-mime-1.13.0.mk.patch
Patch9: semi-emh-cfg.patch
Patch10: semi-cfg.patch
Patch11: semi-rmailmime-cfg.patch
Patch12: semi-1.14.3-CAN-2003-0440.patch
PreReq: /sbin/install-info
BuildRoot: %{_tmppath}/%{name}-%{version}-buildroot
BuildRequires: nkf, apel >= %{apelver}, emacs-X11
Requires: emacs >= %{emacsver}, apel >= %{apelver}
Provides: flim = %{flimver}
Provides: emh = %{emhver}, rmail-mime = %{rmailmimever}
Obsoletes: tm, flim < %{flimver}


## %package el
## Summary: The GNU Emacs lisp sources of semi, flim, emh.
## Group:	Applications/Editors
## Requires: emacs >= %{emacsver}, apel >= %{apelver}
## BuildRequires: emacs >= %{emacsver}, apel >= %{apelver}

%package xemacs
Summary: A library which provides MIME feature for XEmacs 21.
Group: Applications/Editors
## BuildRequires: nkf
## apel is included in XEmacs 20.1.14.x (x>=2)
Requires: xemacs >= %{xemacsver}, apel-xemacs >= %{apelver}
BuildRequires: xemacs >= %{xemacsver}, apel-xemacs >= %{apelver}
Provides: semi-xemacs = %{semiver}
Provides: flim-xemacs = %{flimver}
Provides: emh-xemacs = %{emhver}
Provides: rmail-mime-xemacs = %{rmailmimever}
BuildArch: noarch

## %package xemacs-el
## Summary: The XEmacs lisp sources of semi, flim, emh.
## Group:	Applications/Editors
## Requires: xemacs >= %{xemacsver}, apel-xemacs >= %{apelver}
## BuildRequires: xemacs >= %{xemacsver}, apel-xemacs >= %{apelver}


%description
The semi package contains the following .elc files for GNU Emacs 20.7:
APEL 10.2; CLIME 1.13.6; SEMI 1.13.7; EMH 1.10.1; and RMAIL-MIME
1.13.0. APEL (A Portable Emacs Library) provides basic functions and
macros. CLIME is a variation of FLIM, a library that provides basic
features about message representation or encoding. SEMI is a library
that provide MIME features for GNU Emacs, including features like MIME
message viewing and composing. EMH and RMAIL-MIME provide MIME
features for mh-e and rmail, respectively. Note that if you need to
rebuild this SRPM package, you need emacs-20.7 installed.

%description xemacs
The semi package contains the following .elc files for GNU Emacs
21.1.12: APEL 10.2; CLIME 1.13.6; SEMI 1.13.7; EMH 1.10.1; and
RMAIL-MIME 1.13.0. APEL (A Portable Emacs Library) provides basic
functions and macros. CLIME is a variation of FLIM, a library that
provides basic features about message representation or encoding.
SEMI is a library that provide MIME features for GNU Emacs, including
features like MIME message viewing and composing. EMH and RMAIL-MIME
provide MIME features for mh-e and rmail, respectively. Note that if
you need to rebuild this SRPM package, you need emacs-21.1.12
installed.

%prep

rm -rf $RPM_BUILD_DIR/%{flimname}-%{flimver}
rm -rf $RPM_BUILD_DIR/semi-%{semiver}
rm -rf $RPM_BUILD_DIR/emh-%{emhver}
rm -rf $RPM_BUILD_DIR/rmail-mime-%{rmailmimever}

### flim (or clime)
%setup -T -b 1 -D -n %{flimname}-%{flimver}

### semi 
%setup -T -b 2 -D -n semi-%{semiver}
%patch0 -p1 -b .info
## %patch5 -p0 -b .me
## %patch6 -p0 -b .mp
%patch7 -p1 -b .smi
%patch10 -p1 -b .cfg
%patch12 -p1 -b .mktmp

### emh
%setup -T -b 3 -D -n emh-%{emhver}
%patch9 -p1 -b .cfg

### rmail-mime
%setup -T -b 4 -D -n rmail-mime-%{rmailmimever}
%patch8 -p1 -b .mk
%patch11 -p1 -b .cfg

%build


%install
[ "x$RPM_BUILD_ROOT" != "x/" ] && rm -rf $RPM_BUILD_ROOT
[ "x$RPM_BUILD_ROOT" != "x/" ] && mkdir -p $RPM_BUILD_ROOT


############### packages for GNU Emacs #################

### flim (or clime)
( cd $RPM_BUILD_DIR/%{flimname}-%{flimver}
rm -f mailcap*
make LISPDIR=$RPM_BUILD_ROOT%{lispdir}
make PREFIX=$RPM_BUILD_ROOT%{_prefix} install
)

### semi (build-depends: flim)
( cd $RPM_BUILD_DIR/semi-%{semiver}
make LISPDIR=$RPM_BUILD_ROOT%{lispdir}
make LISPDIR=$RPM_BUILD_ROOT%{lispdir} info
make LISPDIR=$RPM_BUILD_ROOT%{lispdir} install
)

### emh (build-depends: flim, semi)
( cd $RPM_BUILD_DIR/emh-%{emhver}
make LISPDIR=$RPM_BUILD_ROOT%{lispdir} 
make LISPDIR=$RPM_BUILD_ROOT%{lispdir} install
)

### rmail-mime (build-depends: flim, semi)
( cd $RPM_BUILD_DIR/rmail-mime-%{rmailmimever}
make LISPDIR=$RPM_BUILD_ROOT%{lispdir}
make LISPDIR=$RPM_BUILD_ROOT%{lispdir} install
)

## clean up Emacs .elc's before rebuilding them with XEmacs
cd $RPM_BUILD_DIR
for d in %{flimname}-%{flimver} semi-%{semiver} emh-%{emhver} \
	rmail-mime-%{rmailmimever}; do (cd $d && make clean) ; done


############### packages for XEmacs ##################

### flim (or clime)
( cd $RPM_BUILD_DIR/%{flimname}-%{flimver}
make EMACS=xemacs PACKAGEDIR=$RPM_BUILD_ROOT%{pkgdir} install-package
)

### semi (build-depends: flim)
( cd $RPM_BUILD_DIR/semi-%{semiver}
make EMACS=xemacs PACKAGEDIR=$RPM_BUILD_ROOT%{pkgdir} install-package
)

### emh (build-depends: flim, semi)
( cd $RPM_BUILD_DIR/emh-%{emhver}
make EMACS=xemacs PACKAGEDIR=$RPM_BUILD_ROOT%{pkgdir} install-package
)

### rmail-mime (build-depends: flim, semi)
( cd $RPM_BUILD_DIR/rmail-mime-%{rmailmimever}
make EMACS=xemacs PACKAGEDIR=$RPM_BUILD_ROOT%{pkgdir} install-package
)


################# Info and other Docs. #####################

### Info
mkdir -p $RPM_BUILD_ROOT%{_datadir}/info
( cd $RPM_BUILD_DIR/semi-%{semiver}
install -m 644 mime-ui-en.info mime-ui-ja.info \
	$RPM_BUILD_ROOT%{_datadir}/info
)

(cd $RPM_BUILD_ROOT%{_datadir}/info && \
	nkf -e mime-ui-ja.info > mime-ui-ja.info.euc && \
	mv mime-ui-ja.info.euc mime-ui-ja.info )

### Other documentations.
mkdir -p $RPM_BUILD_DIR/semi-%{semiver}/{%{flimname},semi,emh,rmail-mime}

cd $RPM_BUILD_DIR/%{flimname}-%{flimver}
for f in ChangeLog README.en README.ja NEWS VERSION; do \
	(gzip -v9 $f && install -m 644 $f.gz $RPM_BUILD_DIR/semi-%{semiver}/%{flimname}); done

cd $RPM_BUILD_DIR/semi-%{semiver}
for f in ChangeLog README.en NEWS TODO VERSION; do \
	(gzip -v9 $f && install -m 644 $f.gz $RPM_BUILD_DIR/semi-%{semiver}/semi-%{semiver}); done

cd $RPM_BUILD_DIR/emh-%{emhver}
for f in ChangeLog README.en; do \
	(gzip -v9 $f && install -m 644 $f.gz $RPM_BUILD_DIR/semi-%{semiver}/emh); done

cd $RPM_BUILD_DIR/rmail-mime-%{rmailmimever}
for f in ChangeLog README.en; do \
	(gzip -v9 $f && install -m 644 $f.gz $RPM_BUILD_DIR/semi-%{semiver}/rmail-mime); done



%post
/sbin/install-info /usr/share/info/mime-ui-ja.info \
	/usr/share/info/dir --section="MIME Interface"

/sbin/install-info /usr/share/info/mime-ui-en.info \
	/usr/share/info/dir --section="MIME Interface"


%preun
/sbin/install-info --delete \
	/usr/share/info/mime-ui-ja.info /usr/share/info/dir \
	--section="MIME Interface"

/sbin/install-info --delete /usr/share/info/mime-ui-en.info \
	/usr/share/info/dir --section="MIME Interface"


%clean
[ "x$RPM_BUILD_ROOT" != "x/" ] && rm -rf $RPM_BUILD_ROOT

%{__rm} -rf $RPM_BUILD_DIR/%{flimname}-%{flimver}
%{__rm} -rf $RPM_BUILD_DIR/semi-%{semiver}
%{__rm} -rf $RPM_BUILD_DIR/emh-%{emhver}
%{__rm} -rf $RPM_BUILD_DIR/rmail-mime-%{rmailmimever}


%files
%defattr(-,root,root)
%doc ../semi-%{semiver}/%{flimname}
%doc ../semi-%{semiver}/semi
%doc ../semi-%{semiver}/emh
%doc ../semi-%{semiver}/rmail-mime
%{_datadir}/info/mime-ui-en.info.gz
%{_datadir}/info/mime-ui-ja.info.gz
## %{lispdir}/*/*.elc
%{lispdir}/*/*.*

## %files el
## %defattr(-,root,root)
## %{lispdir}/*/*.el

%files xemacs
%defattr(-,root,root)
## %{xlispdir}/*/*.elc
%{pkgdir}/*/*/*.*

## %files xemacs-el
## %defattr(-,root,root)
## %{xlispdir}/*/*.el

 
%changelog
* Mon Jul 14 2003 Jens Petersen <petersen@redhat.com> - 1.14.3-8.72
- apply semi-1.14.3-CAN-2003-0440.patch from debian to fix temp file
  vulnerability (#98817)
- make it noarch

* Mon Oct 15 2001 Jens Petersen <petersen@redhat.com> 1.14.3-7.7
- cleaned up spec file (use ExcludeArch instead of "#ifnarch ia64"; 
  BuildPreReq == BuildRequires)
- simplified descriptions
- added patches to {SEMI,EMH,RMAIL-MIME}-CFG so that the xemacs packages built
  are used in builds of depend packages: hence semi-xemacs is no longer
  incestuous; ie semi-xemacs can build properly without a semi-xemacs installed

* Thu Sep  6 2001 Jens Petersen <petersen@redhat.com> 1.14.3-7
- build against apel-10.3
- patch to RMAIL-MIME-MK for RMAIL_MIME_PREFIX typo

* Tue Aug 14 2001 SATO Satoru <ssato@redhat.com> - 1.14.3-6
- BuildRequires: emacs-X11 (! emacs)

* Wed Jul 25 2001 SATO Satoru <ssato@redhat.com>
- remove flim/mailcap.el (#51144)
- comment out build-time-dependency for apel-xemacs because
- if xemacs is installed apel will also included in it.

* Tue Jul 10 2001 SATO Satoru <ssato@redhat.com>
- BuildPrereq: emacs >= %%{emacsver}
- BuildRequires: emacs >= %%{emacsver}
- BuildPrereq: xemacs >= %%{xemacsver} (%%ifnarch ia64)
- BuildRequires: xemacs >= %%{xemacsver} (%%ifnarch ia64)

* Mon Jun 25 2001 SATO Satoru <ssato@redhat.com>
- not to build xemacs* for IA64
- omitted "Emacs=emacs"

* Mon Jun 25 2001 SATO Satoru <ssato@redhat.com>
- *-el were disused

* Sat Jun 23 2001 SATO Satoru <ssato@redhat.com>
- semi-xemacs: remove dependency for apel-xemacs
- semi-xemacs: add buildtime-dependencies
- semi-xemacs: fix wrong file-lists in %%files*
- the Emacs lisp sources removed from semi, semi-xemacs
  and moved those into semi-el, semi-xemacs-el packages.

* Tue Jun 19 2001 SATO Satoru <ssato@redhat.com>
- semi: 1.14.3, flim: 1.14.3, emh: 1.14.1, rmail-mime: 1.13.0
- clean up SPEC
- multi-binarized (semi and semi-xemacs)
- removed apel (moved into "apel")
- added PreReq: /sbin/install-info
- %%post: /usr/info -> /usr/share/info
- use flim instead of clime by default
- fixed Copyright

* Wed Aug 02 2000 Yukihiro Nakai <ynakai@redhat.com>
- Rebuild for 7.0J beta

* Wed May 10 2000 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-6
- apel updated to 10.2

* Mon Jan 24 2000 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-5
- added patch (see emacs-mime-ja: 00303) to format texinfo correctly

* Thu Dec 24 1999 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-4
- updated in sync with apel-10.0 / clime-1.13.6 release

* Wed Dec  1 1999 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-3
- change Group to Applications/Editors/EmacsLisp

* Mon Nov 29 1999 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-2
- added patches (see emacs-mime-ja:00183, emacs-mime-ja:00184)
- now emh-1.10.1 and rmail-mime-1.13.0 are also included
- documentation files are properly stored under /usr/doc directory

* Wed Nov  3 1999 MATSUBAYASHI 'Shaolin' Kohji
- 1.13.7-1
- updated to apel-9.23 / clime-1.13.5 / semi-1.13.7 release
- added Japanese / English info files to be installed
